org.apache.cassandra.dht

## Class ByteOrderedPartitioner

- java.lang.Object
- - org.apache.cassandra.dht.ByteOrderedPartitioner

All Implemented Interfaces:
  IPartitioner

    public class ByteOrderedPartitioner
    extends java.lang.Object
    implements IPartitioner

### Nested Class Summary

Nested Classes
`static class` `ByteOrderedPartitioner.BytesToken`

### Field Summary

Fields
`static java.math.BigInteger` `BYTE_MASK`
`static ByteOrderedPartitioner` `instance`
`static ByteOrderedPartitioner.BytesToken` `MINIMUM`

### Constructor Summary

Constructors
Constructor and Description
`ByteOrderedPartitioner()`

### Method Summary

All Methods Instance Methods Concrete Methods
`DecoratedKey` `decorateKey(java.nio.ByteBuffer key)` Transform key to object representation of the on-disk format.
`java.util.Map<Token,java.lang.Float>` `describeOwnership(java.util.List<Token> sortedTokens)` Calculate the deltas between tokens in the ring in order to compare relative sizes.
`ByteOrderedPartitioner.BytesToken` `getMinimumToken()`
`ByteOrderedPartitioner.BytesToken` `getRandomToken()`
`ByteOrderedPartitioner.BytesToken` `getToken(java.nio.ByteBuffer key)`
`Token.TokenFactory` `getTokenFactory()`
`AbstractType<?>` `getTokenValidator()`
`ByteOrderedPartitioner.BytesToken` `midpoint(Token lt, Token rt)` Calculate a Token representing the approximate "middle" of the given range.
`boolean` `preservesOrder()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### MINIMUM

    public static final ByteOrderedPartitioner.BytesToken MINIMUM

#### BYTE_MASK

    public static final java.math.BigInteger BYTE_MASK

#### instance

    public static final ByteOrderedPartitioner instance

### Constructor Detail

#### ByteOrderedPartitioner

    public ByteOrderedPartitioner()

### Method Detail

#### getToken

    public ByteOrderedPartitioner.BytesToken getToken(java.nio.ByteBuffer key)

Specified by:
  `getToken` in interface `IPartitioner`
Returns:
  a Token that can be used to route a given key (This is NOT a method to create a Token from its string representation; for that, use TokenFactory.fromString.)

#### decorateKey

    public DecoratedKey decorateKey(java.nio.ByteBuffer key)

Description copied from interface: `IPartitioner`
Transform key to object representation of the on-disk format.

Specified by:
  `decorateKey` in interface `IPartitioner`
Parameters:
  `key` - the raw, client-facing key
Returns:
  decorated version of key

#### midpoint

    public ByteOrderedPartitioner.BytesToken midpoint(Token lt,
                                                      Token rt)

Description copied from interface: `IPartitioner`
Calculate a Token representing the approximate "middle" of the given range.

Specified by:
  `midpoint` in interface `IPartitioner`
Returns:
  The approximate midpoint between left and right.

#### getMinimumToken

    public ByteOrderedPartitioner.BytesToken getMinimumToken()

Specified by:
  `getMinimumToken` in interface `IPartitioner`
Returns:
  A Token smaller than all others in the range that is being partitioned. Not legal to assign to a node or key. (But legal to use in range scans.)

#### getRandomToken

    public ByteOrderedPartitioner.BytesToken getRandomToken()

Specified by:
  `getRandomToken` in interface `IPartitioner`
Returns:
  a randomly generated token

#### getTokenFactory

    public Token.TokenFactory getTokenFactory()

Specified by:
  `getTokenFactory` in interface `IPartitioner`

#### preservesOrder

    public boolean preservesOrder()

Specified by:
  `preservesOrder` in interface `IPartitioner`
Returns:
  True if the implementing class preserves key order in the Tokens it generates.

#### describeOwnership

    public java.util.Map<Token,java.lang.Float> describeOwnership(java.util.List<Token> sortedTokens)

Description copied from interface: `IPartitioner`
Calculate the deltas between tokens in the ring in order to compare relative sizes.

Specified by:
  `describeOwnership` in interface `IPartitioner`
Parameters:
  `sortedTokens` - a sorted List of Tokens
Returns:
  the mapping from 'token' to 'percentage of the ring owned by that token'.

#### getTokenValidator

    public AbstractType<?> getTokenValidator()

Specified by:
  `getTokenValidator` in interface `IPartitioner`